﻿using SAIB_Web_Api.BusinessManager;
using SAIB_Web_Api.Helper;
using SAIB_Web_Api.Models.Response;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Security.Authentication;
using System.Web.Http;

namespace SAIB_Web_Api.Controllers
{
    public class LoginController : ApiController
    {
        LoginManager _loginManager = new LoginManager();

        [Route(RouteConfig.Login)]
        [HttpPost]
        public List<LoginResponseDetail> Login([FromBody]LoginRequest loginRequest)
        {
            try
            {
                return _loginManager.Login(loginRequest.Username, loginRequest.Password);
            }
            catch (AuthenticationException)
            {
                throw HttpErrorResponseHelper.GenerateUnauthorised(Request);
            }
            catch (Exception ex)
            {
                throw HttpErrorResponseHelper.GenerateInternalServerError(Request, ex.Message);
            }
        }

        [Route(RouteConfig.UserAlreadyLoginYes)]
        [HttpPost]
        public LoginResponse UserAlreadyLoginYes(AlreadyLoginYesRequest alreadyLoginYesRequest)
        {
            try
            {
                return _loginManager.UserAlreadyLoginYes(alreadyLoginYesRequest.UserID, alreadyLoginYesRequest.Username, alreadyLoginYesRequest.Password);
            }
            catch (AuthenticationException)
            {
                throw HttpErrorResponseHelper.GenerateUnauthorised(Request);
            }
            catch (Exception ex)
            {
                throw HttpErrorResponseHelper.GenerateInternalServerError(Request, ex.Message);
            }
        }

        [Route(RouteConfig.UserAlreadyLoginNo)]
        [HttpGet]
        public string UserAlreadyLoginNo(string UserID)
        {
            try
            {
                return _loginManager.UserAlreadyLoginNo(UserID);
            }
            catch (AuthenticationException)
            {
                throw HttpErrorResponseHelper.GenerateUnauthorised(Request);
            }
            catch (Exception ex)
            {
                throw HttpErrorResponseHelper.GenerateInternalServerError(Request, ex.Message);
            }
        }

        [Route(RouteConfig.LogOut)]
        [HttpGet]
        public bool LogOut(string UserID, string CurrentLogin_ID)
        {
            try
            {
                return _loginManager.LogOut(UserID, CurrentLogin_ID);
            }
            catch (AuthenticationException)
            {
                throw HttpErrorResponseHelper.GenerateUnauthorised(Request);
            }
            catch (Exception ex)
            {
                throw HttpErrorResponseHelper.GenerateInternalServerError(Request, ex.Message);
            }
        }
    }
}
