﻿using gen_agentKeys;
using MainRemit;
using MyDatabase;
using SAIB_Web_Api.DataManager;
using SAIB_Web_Api.Models.Response;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Globalization;
using System.Linq;
using System.Web;
using System.Text;
using System.Security.Cryptography;
using System.IO;
using BCrypt.Net;

namespace SAIB_Web_Api.BusinessManager
{
    public class LoginManager
    {
        string MacAddress = "0";
        bool IsWebSecure = false;
        List<LoginResponse> loginlistResponse = new List<LoginResponse>();
        LoginResponse loginResponse = new LoginResponse();

        List<UserAlreadyLoginResponse> UserAlreadyLoginlistResponse = new List<UserAlreadyLoginResponse>();
        UserAlreadyLoginResponse UserAlreadyLoginResponse = new UserAlreadyLoginResponse();
        //private static readonly string key = "XOR";

        public List<LoginResponseDetail>Login(string username, string password)
        {
            try
            {
                DateTime localTime = DateTime.Now;
                string timeString24Hour = localTime.ToString("HH:mm:ss", CultureInfo.CurrentCulture);
                string Hr = localTime.ToString("HH", CultureInfo.CurrentCulture);
                string MN = localTime.ToString("mm", CultureInfo.CurrentCulture);
                decimal tm = Convert.ToDecimal(Hr + "." + MN);
                string day = localTime.DayOfWeek.ToString();
                string fsttwoofCha = day.Substring(0, 2);

                cbAuthentication MyAuthentication = new cbAuthentication(csCommon.ConnectionString);
                MyAuthentication.RedirectSuccessfulLogin = "HomePage.aspx";
                MyAuthentication.RedirectPasswordexpired = "PasswordExpired.aspx";
                MyAuthentication.RedirectFirstTimeLogin = "LoginFirstTime.aspx";
                MyAuthentication.UserID = username;

                string key = "!1A3g2D4s9K556g7";
                string Decrypted = AES_Decrypt(password, key);

                MyAuthentication.Password = Decrypted;
                MyAuthentication.EncryptionRequired = true;
                MyAuthentication.IsWebSecure = IsWebSecure;
                MyAuthentication.HostIP = System.Web.HttpContext.Current.Request.ServerVariables["HTTP_X_FORWARDED_FOR"];
                MyAuthentication.MacAddress = MacAddress;
                MyAuthentication.PasswordLockCounter = csCommon.PasswordLockCounter;

                string LoginStatus = string.Empty;
                LoginStatus = MyAuthentication.Login().ToString();
                //LoginStatus = MyAuthentication.LDAPLogin(MyAuthentication.UserID, MyAuthentication.Password).ToString();
                loginResponse.Mac_Address = MacAddress;
                loginResponse.G_UserID = MyAuthentication.UserID;
                loginResponse.G_UserName = MyAuthentication.UserName.ToString();
                #region Autorization token



                #endregion


                if (LoginStatus.StartsWith("User Already Login."))
                {                   
                    //throw new Exception("User Already Login.");
                    UserAlreadyLoginResponse.Message = "User Already Login.";
                    UserAlreadyLoginResponse.UserID = MyAuthentication.UserID;
                    UserAlreadyLoginlistResponse.Add(UserAlreadyLoginResponse);

                }
                else
                {
                    
                    loginResponse =  SuccessfulLogin(MyAuthentication, LoginStatus);
                    loginlistResponse.Add(loginResponse);
                }

                List<LoginResponseDetail> LoginResponselistDetail = new List<LoginResponseDetail>();
                LoginResponseDetail loginResponseDetail = new LoginResponseDetail();
                loginResponseDetail.loginResponse = loginlistResponse;
                loginResponseDetail.UserAlreadyLoginResponse = UserAlreadyLoginlistResponse;
                LoginResponselistDetail.Add(loginResponseDetail);
                return LoginResponselistDetail;
            }
            catch (Exception ex)
            {
                string _msg = string.Empty;
                if (ex.Message.IndexOf("Unauthorized User") > 0)
                {
                    _msg = "Incorrect login details.";
                }
                else if (ex.Message.IndexOf("Incorrect password") > 0)
                {
                    _msg = "Incorrect login details.";
                }
                else if (ex.Message.IndexOf("User Already Login.") > 0)
                {
                    _msg = "User Already Login.";
                }
                else if (ex.Message.IndexOf("Unauthorized Access.") > 0)
                {
                    _msg = "You are not authorize to access this application. Please contact to Administrator.";
                }
                else
                {
                    _msg = ex.Message;
                }
                throw new Exception(_msg);
            }
        }
   
        private void UpdateDealVoucher()
        {
            if (loginResponse.G_UserGroup == UserGroupType.SR.GetHashCode().ToString())
            {
                SqlConnection Conn = new SqlConnection(csCommon.ConnectionString);
                SqlCommand Comm = new SqlCommand();
                try
                {
                    Comm.Connection = Conn;
                    Comm.CommandType = CommandType.StoredProcedure;
                    Comm.CommandText = "UpdateStatus_DealVoucher";
                    Comm.CommandTimeout = 200;
                    Conn.Open();
                    Comm.ExecuteNonQuery();
                }
                catch (Exception ex)
                {

                }
                finally
                {
                    Conn.Dispose();
                    Comm.Dispose();
                }
            }
        }

        public LoginResponse UserAlreadyLoginYes(string UserID, string UserName , string Password)
        {
            try
            {
                cbAuthentication MyAuthentication = new cbAuthentication(csCommon.ConnectionString);
                MyAuthentication.RedirectSuccessfulLogin = "HomePage.aspx";
                string HostIP = System.Web.HttpContext.Current.Request.UserHostAddress.ToString();
                MyAuthentication.AddAttemptLog(UserID, HostIP, MacAddress, "Session Forcefully Taken");
                MyAuthentication.UserID = UserID;
                string key = "!1A3g2D4s9K556g7";
                string Decrypted = AES_Decrypt(Password, key);
                MyAuthentication.Password = Decrypted;
                MyAuthentication.EncryptionRequired = true;

                SuccessfulLogin(MyAuthentication, MyAuthentication.RedirectSuccessfulLogin);
                loginResponse.Mac_Address = MacAddress;
                loginResponse.G_UserID = UserID;
                loginResponse.G_UserName = UserName;
                return loginResponse;
            }
            catch (Exception ex)
            {
                throw ex;
            }

        }

        public string UserAlreadyLoginNo(string UserID)
        {
            try
            {
                string Result = string.Empty;
                cbAuthentication MyAuthentication = new cbAuthentication(csCommon.ConnectionString);
                string HostIP = System.Web.HttpContext.Current.Request.UserHostAddress.ToString();
                MyAuthentication.AddAttemptLog(UserID, HostIP, MacAddress, "Session Not Taken By User");
                Result = Convert.ToString("User Already Login.");
                return Result;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        private LoginResponse SuccessfulLogin(cbAuthentication MyAuthentication, string LoginStatus)
        {         
            DateTime localTime = DateTime.Now;
            string timeString24Hour = localTime.ToString("HH:mm:ss", CultureInfo.CurrentCulture);
            string Hr = localTime.ToString("HH", CultureInfo.CurrentCulture);
            string MN = localTime.ToString("mm", CultureInfo.CurrentCulture);
            decimal tm = Convert.ToDecimal(Hr + "." + MN);
            string day = localTime.DayOfWeek.ToString();
            string fsttwoofCha = day.Substring(0, 2);

            if (LoginStatus.StartsWith("Error: "))
            {
                throw new Exception(LoginStatus.ToString());
            }
            else if (LoginStatus.StartsWith("Your password has been expired.") || LoginStatus.StartsWith("PasswordExpired.aspx"))
            {
                throw new Exception("Your password has been expired");
                // Response.Redirect(MyAuthentication.RedirectPasswordexpired, false);
            }
            else if (LoginStatus.StartsWith("Alert: First time login change your password."))
            {
                throw new Exception("Alert: First time login change your password.");
                // Response.Redirect(MyAuthentication.RedirectFirstTimeLogin, false);
            }
            else
            {
                #region Login Information

                loginResponse.G_UserGroup = MyAuthentication.Group.ToString();
                loginResponse.G_DtLogin = DateTime.Now;
                loginResponse.G_TmLogin = DateTime.Now;

                #endregion

                MyAuthentication.GetUserInfo(MyAuthentication.UserID);

                loginResponse.G_UserEmailID = MyAuthentication.Email.ToString();
                loginResponse.Group_Name = MyAuthentication.Group_Name.ToString();
                loginResponse.PassExpiryDt = MyAuthentication.ExpiryDt.ToString();

                #region Branch Information

                loginResponse.G_Branch_Name = MyAuthentication.Branch_Name.ToString();
                loginResponse.G_Branch_ID = MyAuthentication.Branch_ID.ToString();
                loginResponse.Base_Currency_ID = MyAuthentication.Base_Currency_ID.ToString();
                loginResponse.CurrencyShortName = MyAuthentication.CurrencyShortName.ToString();
                loginResponse.Base_Country_ID = MyAuthentication.Country_ID.ToString();
                loginResponse.IsArebic = MyAuthentication.IsArebic.ToString();
                loginResponse.IsSubAgent = MyAuthentication.IsSubAgent.ToString();
                loginResponse.IsSendSpecific = MyAuthentication.IsSendSpecific.ToString();
                loginResponse.IsRecSpecific = MyAuthentication.IsRecSpecific.ToString();
                loginResponse.IsManualEntry = MyAuthentication.IsManualEntry.ToString();

                #endregion

                #region Agent Information

                loginResponse.SubUserGroup_Id = MyAuthentication.SubUserGroup_Id.ToString();
                loginResponse.SubGroup_Name = MyAuthentication.SubGroup_Name.ToString();
                loginResponse.G_Agent_ID = MyAuthentication.Agent_ID.ToString();
                loginResponse.CountryName = MyAuthentication.CountryName.ToString();
                loginResponse.Agent_Country_ID = MyAuthentication.Agent_Country_ID.ToString();
                loginResponse.Agent_City_ID = MyAuthentication.Agent_City_ID.ToString();
                loginResponse.Agent_Location_ID = MyAuthentication.Agent_Location_ID.ToString();
                loginResponse.Agent_Currency_ID = MyAuthentication.Agent_Currency_ID.ToString();
                loginResponse.Sending_SettlementCurrency = MyAuthentication.Agent_SettlementCurrency.ToString();
                loginResponse.Sending_SttlementCCYName = MyAuthentication.SettlementCCYName.ToString();
                loginResponse.IndividualTransactionLimit = MyAuthentication.IndividualTransactionLimit.ToString();
                loginResponse.AgentCountryTimeDiff = "0";
                loginResponse.Agent_Branch_ID = MyAuthentication.AgentBranchID.ToString();
                loginResponse.TransactionYearStartDate = MyAuthentication.TransactionYearStartDate.ToString();
                loginResponse.TransactionYearEndDate = MyAuthentication.TransactionYearEndDate.ToString();

                #endregion
                //For Agent and SR IsHO
                loginResponse.IsHeadOffice = MyAuthentication.IsHeadOffice.ToString();

                #region For Populate Tree

                loginResponse.TreeMainNode = MyAuthentication.TreeMainNode.ToString();

                #endregion

                loginResponse.G_Branch_Address = MyAuthentication.Branch_Address.ToString();
                loginResponse.G_Phone = MyAuthentication.Branch_Phone.ToString();
                loginResponse.G_Fax = MyAuthentication.Branch_Fax.ToString();
                loginResponse.G_Email = MyAuthentication.Branch_Email.ToString();

                #region For Agent Working time
                if (loginResponse.G_Agent_ID != "0")
                {
                    csQueryBuilder _query2 = new csQueryBuilder();
                    _query2.TableName = "SpCheckAgentLogin";
                    _query2.QryType = csQueryBuilder.QueryType.Procedure;
                    _query2.ProcedureType = csQueryBuilder.ProcType.Select;
                    _query2.ViewType = csQueryBuilder.VType.Process;
                    _query2.Add("@Agent", SqlDbType.Int, loginResponse.G_Agent_ID);
                    _query2.Add("@Agent_branchid", SqlDbType.Int, loginResponse.Agent_Branch_ID);
                    _query2.Add("@UserId", SqlDbType.NVarChar, loginResponse.G_UserID);
                    _query2.Add("@Type", SqlDbType.Int, "3");
                    _query2.Run();
                    csDatabase Mydb2 = new csDatabase(csCommon.ConnectionString);
                    string CheckAgent = Mydb2.Return_SingleField(_query2.MyCmd, "ISCheckAgentLogin");
                    if (Convert.ToBoolean(CheckAgent) == true)
                    {
                        csQueryBuilder _query1 = new csQueryBuilder();
                        _query1.TableName = "SpCheckAgentLogin";
                        _query1.QryType = csQueryBuilder.QueryType.Procedure;
                        _query1.ProcedureType = csQueryBuilder.ProcType.Select;
                        _query1.ViewType = csQueryBuilder.VType.Process;
                        _query1.Add("@Agent", SqlDbType.Int, loginResponse.G_Agent_ID);
                        _query1.Add("@Agent_branchid", SqlDbType.Int, loginResponse.Agent_Branch_ID);
                        _query1.Add("@Day", SqlDbType.NVarChar, fsttwoofCha.ToString());
                        _query1.Add("@Type", SqlDbType.Int, "1");
                        _query1.Add("@UserId", SqlDbType.NVarChar, loginResponse.G_UserID);
                        _query1.Add("@TmEN", SqlDbType.Decimal, tm.ToString());
                        _query1.Run();
                        csDatabase Mydb1 = new csDatabase(csCommon.ConnectionString);
                        DataTable Getdata = Mydb1.Return_DataTable(_query1.MyCmd);
                        if (Getdata.Rows.Count == 0)
                        {
                            MyAuthentication.AddAttemptLog(loginResponse.G_UserID, System.Web.HttpContext.Current.Request.UserHostAddress.ToString(), loginResponse.Mac_Address, "Login Failed: Incorrect Branch Time.");

                            throw new Exception("Login Failed: Incorrect Branch Time.");
                        }
                    }
                }
                #endregion For Agent Working time

                if (LoginStatus.StartsWith("Alert: "))
                {
                    if (LoginStatus.StartsWith("Alert: First time login change your password."))
                    {
                        throw new Exception("Alert: First time login change your password.");
                    }
                    else
                    {
                        loginResponse.G_Information = LoginStatus;
                    }
                }
                else
                {
                    loginResponse.G_Information = string.Empty;
                }

                #region Login Log
                csQueryBuilder _Query = new csQueryBuilder();
                _Query.TableName = "spLoginDetails";
                _Query.QryType = csQueryBuilder.QueryType.Procedure;
                _Query.ViewType = csQueryBuilder.VType.Process;
                _Query.ProcedureType = csQueryBuilder.ProcType.Insert;
                _Query.Add("@UserId", SqlDbType.NVarChar, MyAuthentication.UserID);
                _Query.Add("@Agent_ID", SqlDbType.Int, MyAuthentication.Agent_ID.ToString());
                _Query.Add("@Ex_Branch_ID", SqlDbType.Int, MyAuthentication.Branch_ID.ToString());

                _Query.Run();

                csDatabase LoginLog = new csDatabase(csCommon.ConnectionString);
                loginResponse.CurrentLogin_ID = LoginLog.Return_SingleField(_Query.MyCmd, "LatestID");


                #endregion

                #region Added code for secure login
                //Response.Cookies.Clear();
                //DateTime expiryDate = DateTime.Now.AddMinutes(Session.Timeout);
                //string guid = Guid.NewGuid().ToString();
                //System.Web.Security.FormsAuthenticationTicket ticket = new System.Web.Security.FormsAuthenticationTicket(2, guid, DateTime.Now, expiryDate, true, String.Empty);
                //string encryptedTicket = System.Web.Security.FormsAuthentication.Encrypt(ticket);
                //Session["AuthToken"] = encryptedTicket;
                //System.Web.HttpCookie authenticationCookie = new System.Web.HttpCookie(System.Web.Security.FormsAuthentication.FormsCookieName, encryptedTicket);
                //authenticationCookie.Expires = ticket.Expiration;
                //Response.Cookies.Add(authenticationCookie);
                #endregion

                string UserType = loginResponse.G_UserGroup;
                string SubUserGroup_Id = loginResponse.SubUserGroup_Id;
                loginResponse.CountComplaint = string.Empty;

                if (UserType == "1")
                {
                    csQueryBuilder _query = new csQueryBuilder();
                    _query.TableName = "CountComplaint";
                    _query.QryType = csQueryBuilder.QueryType.Procedure;
                    _query.ProcedureType = csQueryBuilder.ProcType.Select;
                    _query.ViewType = csQueryBuilder.VType.Process;
                    _query.Add("@UserGroupId", SqlDbType.Int, SubUserGroup_Id);
                    _query.Run();

                    csDatabase MyDB = new csDatabase(csCommon.ConnectionString);
                    DataTable MyDT = MyDB.Return_DataTable(_query.MyCmd);

                    if (MyDT.Rows.Count > 0)
                    {
                        string CountComplaint = string.Empty;
                        foreach (DataRow MyRow in MyDT.Rows)
                        {
                            CountComplaint = CountComplaint + "|" + MyRow["item"].ToString();
                        }
                        loginResponse.CountComplaint = CountComplaint.Remove(0, 1);
                    }
                }
                UpdateDealVoucher();

                loginResponse.AuthorizationToken = TokenManager.GenerateToken(MyAuthentication.UserName);

                return loginResponse;
            }
        }
                     
        public object GenerateApiKeys(string AgentId)
        {
            try
            {

                int agentID = Convert.ToInt32(AgentId);
                string secretkey_ = gen_agentKeys_.Secret_key_(AgentId);
                string txnkey_ = gen_agentKeys_.Txn_key_(AgentId);

                secretkey_ = secretkey_.Replace("\\", "");
                txnkey_ = txnkey_.Replace("\\", "");

                var paramObj = new
                {
                    AgentID = agentID,
                    Secretkey_ = secretkey_,
                    Txnkey_ = txnkey_
                };

                int keycheck = commonIUD("usp_Add_agentKeys", paramObj);
                return paramObj;
            }
            catch (Exception exp)
            {
                throw exp;
            }
        }


        public static int commonIUD(string sp_name_, object paramObj)
        {
            int isUpdated = 0; ;

            SqlConnection con = new SqlConnection(csCommon.ConnectionString);
            SqlCommand cmd = new SqlCommand(sp_name_, con);

            cmd.CommandType = CommandType.StoredProcedure;

            foreach (var param_ in paramObj.GetType().GetProperties())
            {

                cmd.Parameters.AddWithValue("@" + param_.Name, param_.GetValue(paramObj, null));
            }

            con.Open();

            isUpdated = cmd.ExecuteNonQuery();
            con.Close();

            return isUpdated;
        }

        public bool LogOut(string UserID, string CurrentLogin_ID)
        {
            bool IsLogOut = false;
            try
            {
                MyDatabase.csQueryBuilder _Query = new MyDatabase.csQueryBuilder();
                _Query.TableName = "spLoginDetails";
                _Query.QryType = MyDatabase.csQueryBuilder.QueryType.Procedure;
                _Query.ViewType = MyDatabase.csQueryBuilder.VType.Process;
                _Query.ProcedureType = MyDatabase.csQueryBuilder.ProcType.Update;

                _Query.Add("@UserId", System.Data.SqlDbType.NVarChar, UserID.ToString());
                _Query.Add("@LogID", System.Data.SqlDbType.NVarChar, CurrentLogin_ID.ToString());

                _Query.Run();

                MyDatabase.csDatabase MyDb = new MyDatabase.csDatabase(csCommon.ConnectionString);
                MyDb.ExecuteNonQuery(_Query.MyCmd);
                string HostIP = System.Web.HttpContext.Current.Request.UserHostAddress.ToString();

                csQueryBuilder MyQry = new csQueryBuilder();
                MyQry.TableName = "sp_LoginAttemptLog";
                MyQry.QryType = csQueryBuilder.QueryType.Procedure;
                MyQry.ProcedureType = csQueryBuilder.ProcType.Insert;
                MyQry.ViewType = csQueryBuilder.VType.Process;
                MyQry.Add("@UserID", SqlDbType.NVarChar, UserID.ToString());
                MyQry.Add("@HostIP", SqlDbType.NVarChar, HostIP);
                MyQry.Add("@MacAddress", SqlDbType.NVarChar, MacAddress.ToString());
                MyQry.Add("@DtTime", SqlDbType.DateTime, DateTime.Now.ToShortTimeString());
                MyQry.Add("@Remarks", SqlDbType.NVarChar, "User Successfully Logged Out");
                MyQry.Run();
                csDatabase MyDB = new csDatabase(csCommon.ConnectionString);
                MyDB.ExecuteNonQuery(MyQry.MyCmd);

                IsLogOut = true;
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return IsLogOut;
        }

        public static string AES_Decrypt(string textToDecrypt, string key)
        {
            RijndaelManaged rijndaelCipher = new RijndaelManaged();
            rijndaelCipher.Mode = CipherMode.CBC;
            rijndaelCipher.Padding = PaddingMode.PKCS7;
            rijndaelCipher.KeySize = 128;
            rijndaelCipher.BlockSize = 128;

            byte[] encryptedData = Convert.FromBase64String(textToDecrypt);
            byte[] keyBytes = Encoding.UTF8.GetBytes(key);

            // Set key and dummy IV (all zeros)
            rijndaelCipher.Key = keyBytes;
            rijndaelCipher.IV = new byte[16]; // Use an all-zero IV

            // Decrypt
            byte[] plainText = rijndaelCipher.CreateDecryptor().TransformFinalBlock(encryptedData, 0, encryptedData.Length);
            return Encoding.UTF8.GetString(plainText);
        }
        
        public static string _AES_Encrypt(string textToEncrypt, string key)
        {
            RijndaelManaged rijndaelCipher = new RijndaelManaged();
            rijndaelCipher.Mode = CipherMode.CBC;
            rijndaelCipher.Padding = PaddingMode.PKCS7;

            rijndaelCipher.KeySize = 0x80;
            rijndaelCipher.BlockSize = 0x80;
            byte[] pwdBytes = Encoding.UTF8.GetBytes(key);
            byte[] keyBytes = new byte[0x10];
            int len = pwdBytes.Length;
            if (len > keyBytes.Length)
            {
                len = keyBytes.Length;
            }
            Array.Copy(pwdBytes, keyBytes, len);
            rijndaelCipher.Key = keyBytes;
            rijndaelCipher.IV = keyBytes;
            ICryptoTransform transform = rijndaelCipher.CreateEncryptor();
            byte[] plainText = Encoding.UTF8.GetBytes(textToEncrypt);
            return Convert.ToBase64String(transform.TransformFinalBlock(plainText, 0, plainText.Length));
        }


        //public static string Decrypt(string encryptedText)
        //{
        //    // Convert the Base64 encoded text back to byte array
        //    byte[] encryptedBytes = Convert.FromBase64String(encryptedText);
        //    byte[] keyBytes = Encoding.UTF8.GetBytes(key);

        //    // XOR operation to decrypt
        //    for (int i = 0; i < encryptedBytes.Length; i++)
        //    {
        //        encryptedBytes[i] = (byte)(encryptedBytes[i] ^ keyBytes[i % keyBytes.Length]);
        //    }

        //    // Convert byte array back to string (decode)
        //    return Encoding.UTF8.GetString(encryptedBytes);
        //}

        //// Method to encrypt (Teleport Encode)
        //public static string Encrypt(string plainText)
        //{
        //    // Convert the plain text to a byte array
        //    byte[] textBytes = Encoding.UTF8.GetBytes(plainText);
        //    byte[] keyBytes = Encoding.UTF8.GetBytes(key);

        //    // XOR operation
        //    for (int i = 0; i < textBytes.Length; i++)
        //    {
        //        textBytes[i] = (byte)(textBytes[i] ^ keyBytes[i % keyBytes.Length]);
        //    }

        //    // Convert the result to Base64 (encode)
        //    return Convert.ToBase64String(textBytes);
        //}
    }

    public class LoginRequest
    {
        public string Username { get; set; }
        public string Password { get; set; }
    }

    public class AlreadyLoginYesRequest
    {
        public string UserID { get; set; }
        public string Username { get; set; }
        public string Password { get; set; }
    }
}